
### dearseqAsymp ----

setwd("Simulations/dearseqAsymp_3norms")
lf <- list.files()
FDR <- list()
Power <- list()
for(norm in c("nonorm", "permprenorm", "permpostnorm")){
  FDR[[norm]] <- list()
  Power[[norm]] <- list()
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
    Power[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
  }
}
for(fn in lf){
  message(fn)
  sampsize <- strsplit(fn, split="_")[[1]][5]
  mc <- as.numeric(strsplit(fn, split="_")[[1]][6])
  norm <- gsub(".txt", "", strsplit(fn, split="_")[[1]][7], fixed = TRUE)
  temp <- read.delim(fn)
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & !temp$TrueDE)/max(sum(temp$adjPval < threshold), 1)
    Power[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & temp$TrueDE)/sum(temp$TrueDE)
  }
}
FDR_avg <- reshape2::melt(lapply(FDR, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "FDR")
colnames(FDR_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
Power_avg <- reshape2::melt(lapply(Power, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "Power")
colnames(Power_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
dearseqAsymp_3norms_FDRPower <- merge.data.frame(FDR_avg, Power_avg)
dearseqAsymp_3norms_FDRPower$Method <- "dearseq asymp"

saveRDS(dearseqAsymp_3norms_FDRPower, file="../../Results/dearseqAsymp_3norms_FDRPower.rds")



### dearseqPerm ----

setwd("../dearseqPerm_3norms")
lf <- list.files()
FDR <- list()
Power <- list()
for(norm in c("nonorm", "permprenorm", "permpostnorm")){
  FDR[[norm]] <- list()
  Power[[norm]] <- list()
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
    Power[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
  }
}
for(fn in lf){
  message(fn)
  sampsize <- strsplit(fn, split="_")[[1]][5]
  mc <- as.numeric(strsplit(fn, split="_")[[1]][6])
  norm <- gsub(".txt", "", strsplit(fn, split="_")[[1]][7], fixed = TRUE)
  temp <- read.delim(fn)
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & !temp$TrueDE)/max(sum(temp$adjPval < threshold), 1)
    Power[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & temp$TrueDE)/sum(temp$TrueDE)
  }
}
FDR_avg <- reshape2::melt(lapply(FDR, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "FDR")
colnames(FDR_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
Power_avg <- reshape2::melt(lapply(Power, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "Power")
colnames(Power_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
dearseqPerm_3norms_FDRPower <- merge.data.frame(FDR_avg, Power_avg)
dearseqPerm_3norms_FDRPower$Method <- "dearseq perm"

saveRDS(dearseqPerm_3norms_FDRPower, file="../../Results/dearseqPerm_3norms_FDRPower.rds")


### Wilcoxon ----

setwd("../Wilcoxon_3norms")
lf <- list.files()
FDR <- list()
Power <- list()
for(norm in c("nonorm", "permprenorm", "permpostnorm")){
  FDR[[norm]] <- list()
  Power[[norm]] <- list()
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
    Power[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
  }
}
for(fn in lf){
  message(fn)
  sampsize <- strsplit(fn, split="_")[[1]][4]
  mc <- as.numeric(strsplit(fn, split="_")[[1]][5])
  norm <- gsub(".txt", "", strsplit(fn, split="_")[[1]][6], fixed = TRUE)
  temp <- read.delim(fn)
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & !temp$TrueDE)/max(sum(temp$adjPval < threshold), 1)
    Power[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & temp$TrueDE)/sum(temp$TrueDE)
  }
}
FDR_avg <- reshape2::melt(lapply(FDR, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "FDR")
colnames(FDR_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
Power_avg <- reshape2::melt(lapply(Power, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "Power")
colnames(Power_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
Wilcoxon_3norms_FDRPower <- merge.data.frame(FDR_avg, Power_avg)
Wilcoxon_3norms_FDRPower$Method <- "Wilcoxon"

saveRDS(Wilcoxon_3norms_FDRPower, file="../../Results/Wilcoxon_3norms_FDRPower.rds")


### edgeR ----

setwd("../edgeR_3norms")
lf <- list.files()
FDR <- list()
Power <- list()
for(norm in c("nonorm", "permprenorm", "permpostnorm")){
  FDR[[norm]] <- list()
  Power[[norm]] <- list()
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
    Power[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
  }
}
for(fn in lf){
  message(fn)
  sampsize <- strsplit(fn, split="_")[[1]][4]
  mc <- as.numeric(strsplit(fn, split="_")[[1]][5])
  norm <- gsub(".txt", "", strsplit(fn, split="_")[[1]][6], fixed = TRUE)
  temp <- read.delim(fn)
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & !temp$TrueDE)/max(sum(temp$adjPval < threshold), 1)
    Power[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & temp$TrueDE)/sum(temp$TrueDE)
  }
}
FDR_avg <- reshape2::melt(lapply(FDR, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "FDR")
colnames(FDR_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
Power_avg <- reshape2::melt(lapply(Power, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "Power")
colnames(Power_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
edgeR_3norms_FDRPower <- merge.data.frame(FDR_avg, Power_avg)
edgeR_3norms_FDRPower$Method <- "edgeR"

saveRDS(edgeR_3norms_FDRPower, file="../../Results/edgeR_3norms_FDRPower.rds")

### DESeq2 ----

setwd("../DESeq2_3norms")
lf <- list.files()
FDR <- list()
Power <- list()
for(norm in c("nonorm", "permprenorm", "permpostnorm")){
  FDR[[norm]] <- list()
  Power[[norm]] <- list()
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
    Power[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
  }
}
for(fn in lf){
  message(fn)
  sampsize <- strsplit(fn, split="_")[[1]][4]
  mc <- as.numeric(strsplit(fn, split="_")[[1]][5])
  norm <- gsub(".txt", "", strsplit(fn, split="_")[[1]][6], fixed = TRUE)
  temp <- read.delim(fn)
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & !temp$TrueDE)/max(sum(temp$adjPval < threshold), 1)
    Power[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & temp$TrueDE)/sum(temp$TrueDE)
  }
}
FDR_avg <- reshape2::melt(lapply(FDR, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "FDR")
colnames(FDR_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
Power_avg <- reshape2::melt(lapply(Power, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "Power")
colnames(Power_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
DESeq2_3norms_FDRPower <- merge.data.frame(FDR_avg, Power_avg)
DESeq2_3norms_FDRPower$Method <- "DESeq2"

saveRDS(DESeq2_3norms_FDRPower, file="../../Results/DESeq2_3norms_FDRPower.rds")

### voomlimma ----

setwd("../voomlimma_3norms")
lf <- list.files()
FDR <- list()
Power <- list()
for(norm in c("nonorm", "permprenorm", "permpostnorm")){
  FDR[[norm]] <- list()
  Power[[norm]] <- list()
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
    Power[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
  }
}
for(fn in lf){
  message(fn)
  sampsize <- strsplit(fn, split="_")[[1]][4]
  mc <- as.numeric(strsplit(fn, split="_")[[1]][5])
  norm <- gsub(".txt", "", strsplit(fn, split="_")[[1]][6], fixed = TRUE)
  temp <- read.delim(fn)
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & !temp$TrueDE)/max(sum(temp$adjPval < threshold), 1)
    Power[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & temp$TrueDE)/sum(temp$TrueDE)
  }
}
FDR_avg <- reshape2::melt(lapply(FDR, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "FDR")
colnames(FDR_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
Power_avg <- reshape2::melt(lapply(Power, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "Power")
colnames(Power_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
voomlimma_3norms_FDRPower <- merge.data.frame(FDR_avg, Power_avg)
voomlimma_3norms_FDRPower$Method <- "voomlimma"

saveRDS(voomlimma_3norms_FDRPower, file="../../Results/voomlimma_3norms_FDRPower.rds")


### NOISeq ----

setwd("../NOISeq_3norms")
lf <- list.files()
FDR <- list()
Power <- list()
for(norm in c("nonorm", "permprenorm", "permpostnorm")){
  FDR[[norm]] <- list()
  Power[[norm]] <- list()
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
    Power[[norm]][[as.character(threshold)]] <- matrix(NA, ncol=17, nrow=50, dimnames = list(1:50, c(as.character(c(2:10, 12, 15, 20, 40, 60, 80, 100)), "full")))
  }
}
for(fn in lf){
  message(fn)
  sampsize <- strsplit(fn, split="_")[[1]][4]
  mc <- as.numeric(strsplit(fn, split="_")[[1]][5])
  norm <- gsub(".txt", "", strsplit(fn, split="_")[[1]][6], fixed = TRUE)
  temp <- read.delim(fn)
  for(threshold in c(0.00001, 0.0001, 0.001, 0.01, 0.05, 0.1, 0.2)){
    FDR[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & !temp$TrueDE)/max(sum(temp$adjPval < threshold), 1)
    Power[[norm]][[as.character(threshold)]][mc, sampsize] <- sum(temp$adjPval < threshold & temp$TrueDE)/sum(temp$TrueDE)
  }
}
FDR_avg <- reshape2::melt(lapply(FDR, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "FDR")
colnames(FDR_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
Power_avg <- reshape2::melt(lapply(Power, function(x){sapply(x, colMeans, na.rm = TRUE)}), value.name = "Power")
colnames(Power_avg)[c(1,2,4)] <- c("SampleSize", "NominalRate", "Normalization")
NOISeq_3norms_FDRPower <- merge.data.frame(FDR_avg, Power_avg)
NOISeq_3norms_FDRPower$Method <- "NOISeq"

saveRDS(NOISeq_3norms_FDRPower, file="../../Results/NOISeq_3norms_FDRPower.rds")
